
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Support_ticketsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const support_tickets = await db.support_tickets.create(
            {
                id: data.id || undefined,
        
        ticket_number: data.ticket_number
        ||
        null
            ,
            
        category: data.category
        ||
        null
            ,
            
        priority: data.priority
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        subject: data.subject
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        opened_at: data.opened_at
        ||
        null
            ,
            
        resolved_at: data.resolved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await support_tickets.setRequester( data.requester || null, {
            transaction,
        });
        
        await support_tickets.setOrder( data.order || null, {
            transaction,
        });
        
        await support_tickets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.support_tickets.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: support_tickets.id,
            },
            data.attachment_files,
            options,
        );
        

        return support_tickets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const support_ticketsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                ticket_number: item.ticket_number
            ||
            null
            ,
            
                category: item.category
            ||
            null
            ,
            
                priority: item.priority
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                subject: item.subject
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                opened_at: item.opened_at
            ||
            null
            ,
            
                resolved_at: item.resolved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const support_tickets = await db.support_tickets.bulkCreate(support_ticketsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < support_tickets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.support_tickets.getTableName(),
                    belongsToColumn: 'attachment_files',
                    belongsToId: support_tickets[i].id,
                },
                data[i].attachment_files,
                options,
            );
        }
        

        return support_tickets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const support_tickets = await db.support_tickets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.ticket_number !== undefined) updatePayload.ticket_number = data.ticket_number;
        
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.priority !== undefined) updatePayload.priority = data.priority;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.subject !== undefined) updatePayload.subject = data.subject;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.opened_at !== undefined) updatePayload.opened_at = data.opened_at;
        
        
        if (data.resolved_at !== undefined) updatePayload.resolved_at = data.resolved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await support_tickets.update(updatePayload, {transaction});

        
        
        if (data.requester !== undefined) {
            await support_tickets.setRequester(
              
              data.requester,
              
              { transaction }
            );
        }
        
        if (data.order !== undefined) {
            await support_tickets.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await support_tickets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.support_tickets.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: support_tickets.id,
            },
            data.attachment_files,
            options,
        );
        

        return support_tickets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const support_tickets = await db.support_tickets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of support_tickets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of support_tickets) {
                await record.destroy({transaction});
            }
        });


        return support_tickets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const support_tickets = await db.support_tickets.findByPk(id, options);

        await support_tickets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await support_tickets.destroy({
            transaction
        });

        return support_tickets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const support_tickets = await db.support_tickets.findOne(
            { where },
            { transaction },
        );

        if (!support_tickets) {
            return support_tickets;
        }

        const output = support_tickets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.requester = await support_tickets.getRequester({
            transaction
        });
        
        
        output.order = await support_tickets.getOrder({
            transaction
        });
        
        
        output.attachment_files = await support_tickets.getAttachment_files({
            transaction
        });
        
        
        output.organizations = await support_tickets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'requester',
        
        where: filter.requester ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requester.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requester.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachment_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.ticket_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'support_tickets',
                        'ticket_number',
                        filter.ticket_number,
                    ),
                };
            }
            
            if (filter.subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'support_tickets',
                        'subject',
                        filter.subject,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'support_tickets',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.opened_atRange) {
                const [start, end] = filter.opened_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.resolved_atRange) {
                const [start, end] = filter.resolved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    resolved_at: {
                    ...where.resolved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            
            if (filter.priority) {
                where = {
                    ...where,
                priority: filter.priority,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.support_tickets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'support_tickets',
                        'ticket_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.support_tickets.findAll({
            attributes: [ 'id', 'ticket_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['ticket_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.ticket_number,
        }));
    }

    
};

